"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getLocalIdent;

var _path = _interopRequireDefault(require("path"));

var _cssesc = _interopRequireDefault(require("cssesc"));

var _loaderUtils = require("loader-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * getLocalIdent() function taken from css-loader@5.0.0.
 */
// eslint-disable-next-line no-control-regex
const filenameReservedRegex = /["*/:<>?\\|]/g; // eslint-disable-next-line no-control-regex

const reControlChars = /[\u0000-\u001f\u0080-\u009f]/g;

const normalizePath = file => {
  return _path.default.sep === '\\' ? file.replace(/\\/g, '/') : file;
};

const escapeLocalIdent = localident => {
  return (0, _cssesc.default)(localident // For `[hash]` placeholder
  .replace(/^((-?\d)|--)/, '_$1').replace(filenameReservedRegex, '-').replace(reControlChars, '-').replace(/\./g, '-'), {
    isIdentifier: true
  });
};

function getLocalIdent(loaderContext, localIdentName, localName, options) {
  const {
    context,
    hashPrefix
  } = options;
  const {
    resourcePath
  } = loaderContext;
  const request = normalizePath(_path.default.relative(context, resourcePath)); // eslint-disable-next-line no-param-reassign

  options.content = `${hashPrefix + request}\u0000${localName}`;
  const ident = (0, _loaderUtils.interpolateName)(loaderContext, localIdentName, options).replace(/\[local]/gi, localName);
  return escapeLocalIdent(ident);
}
//# sourceMappingURL=getLocalIdent.js.map